# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CardModel(Model):
    """CardModel.

    All required parameters must be populated in order to send to Azure.

    :param ccn: Required. Card number.
    :type ccn: str
    :param full_name: Required. Full name located on the card.
    :type full_name: str
    :param exp_month: Required. Expiration month.
    :type exp_month: int
    :param exp_year: Required. Expiration year.
    :type exp_year: int
    :param cvv: Card verification value (security code). This value is not
     stored permanently.
    :type cvv: str
    :param card_type: Required. Type of card (amex, diners_club_carte_blanche,
     diners_club_international,
     jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
     uatp, mir).
    :type card_type: str
    :param cvv_ttl: Required. Remaining ttl before the CVV gets deleted.
    :type cvv_ttl: int
    :param ttl: The card's time to live in seconds. Once expired the
     card is deleted from the vault.
    :type ttl: int
    """

    _validation = {
        'ccn': {'required': True},
        'full_name': {'required': True},
        'exp_month': {'required': True, 'maximum': 12, 'minimum': 1},
        'exp_year': {'required': True},
        'card_type': {'required': True},
        'cvv_ttl': {'required': True, 'maximum': 1800, 'minimum': 0},
        'ttl': {'maximum': 1800, 'minimum': 60},
    }

    _attribute_map = {
        'ccn': {'key': 'ccn', 'type': 'str'},
        'full_name': {'key': 'fullName', 'type': 'str'},
        'exp_month': {'key': 'expMonth', 'type': 'int'},
        'exp_year': {'key': 'expYear', 'type': 'int'},
        'cvv': {'key': 'cvv', 'type': 'str'},
        'card_type': {'key': 'cardType', 'type': 'str'},
        'cvv_ttl': {'key': 'cvvTtl', 'type': 'int'},
        'ttl': {'key': 'ttl', 'type': 'int'},
    }

    def __init__(self, *, ccn: str, full_name: str, exp_month: int, exp_year: int, card_type: str, cvv_ttl: int, cvv: str=None, ttl: int=None, **kwargs) -> None:
        super(CardModel, self).__init__(**kwargs)
        self.ccn = ccn
        self.full_name = full_name
        self.exp_month = exp_month
        self.exp_year = exp_year
        self.cvv = cvv
        self.card_type = card_type
        self.cvv_ttl = cvv_ttl
        self.ttl = ttl
