# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CardReadModel(Model):
    """CardReadModel.

    All required parameters must be populated in order to send to Azure.

    :param first_six: Required. First six digits of the card number.
    :type first_six: str
    :param last_four: Required. Last four digits of the card number.
    :type last_four: str
    :param ccn: Card number.
    :type ccn: str
    :param exp_month: Required. Expiration month.
    :type exp_month: int
    :param exp_year: Required. Expiration year.
    :type exp_year: int
    :param full_name: Required. Full name located on the card.
    :type full_name: str
    :param card_type: Required. Type of card (amex, diners_club_carte_blanche,
     diners_club_international,
     jcb, laser, visa_electron, visa, mastercard, discover, dankort, maestro,
     uatp, mir).
    :type card_type: str
    :param cvv_ttl: Required. Remaining ttl before the CVV gets deleted.
    :type cvv_ttl: int
    :param ttl: Required. Remaining ttl before the card gets deleted. If -1,
     card lives forever until manually deleted.
    :type ttl: int
    """

    _validation = {
        'first_six': {'required': True},
        'last_four': {'required': True},
        'exp_month': {'required': True, 'maximum': 12, 'minimum': 1},
        'exp_year': {'required': True},
        'full_name': {'required': True},
        'card_type': {'required': True},
        'cvv_ttl': {'required': True, 'maximum': 1800, 'minimum': 0},
        'ttl': {'required': True, 'maximum': 1800, 'minimum': 0},
    }

    _attribute_map = {
        'first_six': {'key': 'firstSix', 'type': 'str'},
        'last_four': {'key': 'lastFour', 'type': 'str'},
        'ccn': {'key': 'ccn', 'type': 'str'},
        'exp_month': {'key': 'expMonth', 'type': 'int'},
        'exp_year': {'key': 'expYear', 'type': 'int'},
        'full_name': {'key': 'fullName', 'type': 'str'},
        'card_type': {'key': 'cardType', 'type': 'str'},
        'cvv_ttl': {'key': 'cvvTtl', 'type': 'int'},
        'ttl': {'key': 'ttl', 'type': 'int'},
    }

    def __init__(self, **kwargs):
        super(CardReadModel, self).__init__(**kwargs)
        self.first_six = kwargs.get('first_six', None)
        self.last_four = kwargs.get('last_four', None)
        self.ccn = kwargs.get('ccn', None)
        self.exp_month = kwargs.get('exp_month', None)
        self.exp_year = kwargs.get('exp_year', None)
        self.full_name = kwargs.get('full_name', None)
        self.card_type = kwargs.get('card_type', None)
        self.cvv_ttl = kwargs.get('cvv_ttl', None)
        self.ttl = kwargs.get('ttl', None)
