# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class CartModel(Model):
    """CartModel.

    All required parameters must be populated in order to send to Azure.

    :param culture_code: Required. ISO 639-1 (language) and ISO 3166-1
     (country) code.
    :type culture_code: str
    :param cart_items: Required. List of cart items.
    :type cart_items: list[~swagger.models.CartItemModel]
    :param total: Required. Total of the cart item amounts. The total is
     validated against the
     sum of the cart item amounts.
    :type total: float
    :param gateway_integers_only: Required. Some payment gateways only accept
     integers. If true, it will multiply
     the total by 100. For instance, 10.01 will be submitted to the gateway
     as 1001. Default value: False .
    :type gateway_integers_only: bool
    """

    _validation = {
        'culture_code': {'required': True},
        'cart_items': {'required': True},
        'total': {'required': True},
        'gateway_integers_only': {'required': True},
    }

    _attribute_map = {
        'culture_code': {'key': 'cultureCode', 'type': 'str'},
        'cart_items': {'key': 'cartItems', 'type': '[CartItemModel]'},
        'total': {'key': 'total', 'type': 'float'},
        'gateway_integers_only': {'key': 'gatewayIntegersOnly', 'type': 'bool'},
    }

    def __init__(self, *, culture_code: str, cart_items, total: float, gateway_integers_only: bool=False, **kwargs) -> None:
        super(CartModel, self).__init__(**kwargs)
        self.culture_code = culture_code
        self.cart_items = cart_items
        self.total = total
        self.gateway_integers_only = gateway_integers_only
